package cs108;

import static java.lang.Byte.toUnsignedLong;
import static java.nio.ByteOrder.LITTLE_ENDIAN;

import java.nio.ByteBuffer;

public final class SipHasher_2_4 {
    private final SipKey key;

    public SipHasher_2_4(SipKey key) {
        this.key = key;
    }

    public long hash(byte[] bytes) {
        State state = new State(key.k0(), key.k1());

        ByteBuffer byteB = ByteBuffer.wrap(bytes);
        byteB.order(LITTLE_ENDIAN);

        // Compression phase: compress all bytes except the last group
        while (byteB.remaining() >= Long.BYTES)
            state.sipCompress(byteB.getLong());

        // Compression phase: compress the last group, along with the length
        int remainingBytesCount = byteB.remaining();
        long lastBytes = (long)bytes.length << (8 * (7 - remainingBytesCount));
        for (int i = bytes.length - 1; i >= bytes.length - remainingBytesCount; --i)
            lastBytes = (lastBytes << 8) | toUnsignedLong(byteB.get(i));
        state.sipCompress(lastBytes);

        // Finalization phase.
        return state.sipFinalize();
    }

    private final static class State {
        public State(long k0, long k1) {
            // TODO à compléter
        }

        public void sipCompress(long m) {
            // TODO à compléter
        }

        public long sipFinalize() {
            // TODO à compléter
            return 0;
        }
    }
}
