package cs108;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public final class SipKey {
    private final long k0, k1;
    
    public SipKey(byte[] bytes) {
        if (! (bytes.length == 16))
            throw new IllegalArgumentException();
        
        ByteBuffer byteB = ByteBuffer.wrap(bytes);
        byteB.order(ByteOrder.LITTLE_ENDIAN);
        this.k0 = byteB.getLong();
        this.k1 = byteB.getLong();
        assert !byteB.hasRemaining();
    }
    
    public long k0() { return k0; }
    public long k1() { return k1; }
}
